Debian Bug report logs - #625828
libipc-sharelite-perl: FTBFS on armel: test failures

version graph

Package: libipc-sharelite-perl; Maintainer for libipc-sharelite-perl is Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>; Source for libipc-sharelite-perl is src:libipc-sharelite-perl.

Reported by: Niko Tyni <ntyni@debian.org>

Date: Fri, 6 May 2011 09:42:02 UTC

Severity: serious

Tags: upstream

Found in version libipc-sharelite-perl/0.17-1

Fixed in version libipc-sharelite-perl/0.17-2

Done: Jonathan Nieder <jrnieder@gmail.com>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#625828; Package libipc-sharelite-perl. (Fri, 06 May 2011 09:42:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
New Bug report received and forwarded. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Fri, 06 May 2011 09:42:08 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: submit@bugs.debian.org
Subject: libipc-sharelite-perl: FTBFS on armel: test failures
Date: Fri, 6 May 2011 12:38:42 +0300
Package: libipc-sharelite-perl
Version: 0.17-1
Severity: serious
Tags: wheezy sid
User: debian-perl@lists.debian.org
Usertags: perl-5.12-transition

This package failed to build on armel only against Perl 5.12.

 https://buildd.debian.org/status/fetch.php?pkg=libipc-sharelite-perl&arch=armel&ver=0.17-1%2Bb1&stamp=1304522076

# Testing IPC::ShareLite 0.17
t/00-load.t ...... ok
t/pod.t .......... ok

#   Failed test 'lock'
#   at t/sharelite.t line 75.
#          got: '1366'
#     expected: '2000'

#   Failed test 'version inc'
#   at t/sharelite.t line 76.
#          got: '1370'
#     expected: '2004'
# Looks like you failed 2 tests of 14.
t/sharelite.t .... 
Dubious, test returned 2 (wstat 512, 0x200)
Failed 2/14 subtests 
t/unicode-key.t .. ok


Haven't investigated whether this is a regression with Perl 5.12 or
something else. The last time it was built on armel was in March 2009.
-- 
Niko Tyni   ntyni@debian.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#625828; Package libipc-sharelite-perl. (Sun, 08 May 2011 06:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Sun, 08 May 2011 06:45:03 GMT) Full text and rfc822 format available.

Message #10 received at 625828@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: 625828@bugs.debian.org
Subject: Re: Bug#625828: libipc-sharelite-perl: FTBFS on armel: test failures
Date: Sun, 8 May 2011 09:43:55 +0300
tags 625828 + squeeze
thanks

On Fri, May 06, 2011 at 12:38:42PM +0300, Niko Tyni wrote:
> Package: libipc-sharelite-perl
> Version: 0.17-1
> Severity: serious
> Tags: wheezy sid
> User: debian-perl@lists.debian.org
> Usertags: perl-5.12-transition
> 
> This package failed to build on armel only against Perl 5.12.
> 
>  https://buildd.debian.org/status/fetch.php?pkg=libipc-sharelite-perl&arch=armel&ver=0.17-1%2Bb1&stamp=1304522076

> Haven't investigated whether this is a regression with Perl 5.12 or
> something else. The last time it was built on armel was in March 2009.

I can reproduce this on abel.debian.org with both squeeze (Perl 5.10)
and sid (5.12), but not on agricola.debian.org at all. Either kernel or
hardware specific? I see from the build log that arnold.debian.org (the
buildd) is running "Linux 2.6.32 armel (armv5tel)" which matches abel.

Running the test under strace:
 strace -f -olog perl -Iblib/lib -Iblib/arch  t/sharelite.t
makes the test succeed, which isn't really helpful.

Will try to make a pure C equivalent of the test next and see if that
makes a difference.

The short term fix may be to retry this on another buildd.
-- 
Niko Tyni   ntyni@debian.org




Added tag(s) squeeze. Request was from Niko Tyni <ntyni@debian.org> to control@bugs.debian.org. (Sun, 08 May 2011 06:45:11 GMT) Full text and rfc822 format available.

Added indication that bug 625828 blocks 619117 Request was from Dominic Hargreaves <dom@earth.li> to control@bugs.debian.org. (Sun, 08 May 2011 17:51:08 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#625828; Package libipc-sharelite-perl. (Tue, 10 May 2011 11:33:11 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dominic Hargreaves <dom@earth.li>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Tue, 10 May 2011 11:33:16 GMT) Full text and rfc822 format available.

Message #19 received at 625828@bugs.debian.org (full text, mbox):

From: Dominic Hargreaves <dom@earth.li>
To: Niko Tyni <ntyni@debian.org>, 625828@bugs.debian.org
Subject: Re: Bug#625828: libipc-sharelite-perl: FTBFS on armel: test failures
Date: Tue, 10 May 2011 12:31:39 +0100
On Sun, May 08, 2011 at 09:43:55AM +0300, Niko Tyni wrote:
> On Fri, May 06, 2011 at 12:38:42PM +0300, Niko Tyni wrote:
> > Package: libipc-sharelite-perl
> > Version: 0.17-1
> > Severity: serious
> > Tags: wheezy sid
> > User: debian-perl@lists.debian.org
> > Usertags: perl-5.12-transition
> > 
> > This package failed to build on armel only against Perl 5.12.
> > 
> >  https://buildd.debian.org/status/fetch.php?pkg=libipc-sharelite-perl&arch=armel&ver=0.17-1%2Bb1&stamp=1304522076
> 
> > Haven't investigated whether this is a regression with Perl 5.12 or
> > something else. The last time it was built on armel was in March 2009.
> 
> I can reproduce this on abel.debian.org with both squeeze (Perl 5.10)
> and sid (5.12), but not on agricola.debian.org at all. Either kernel or
> hardware specific? I see from the build log that arnold.debian.org (the
> buildd) is running "Linux 2.6.32 armel (armv5tel)" which matches abel.
> 
> Running the test under strace:
>  strace -f -olog perl -Iblib/lib -Iblib/arch  t/sharelite.t
> makes the test succeed, which isn't really helpful.
> 
> Will try to make a pure C equivalent of the test next and see if that
> makes a difference.
> 
> The short term fix may be to retry this on another buildd.

I asked the release team to schedule it again, and it also failed
on ancina.debian.org and alwyn.debian.org, so it's apparently not
an uncommon failure on this arch.

-- 
Dominic Hargreaves | http://www.larted.org.uk/~dom/
PGP key 5178E2A5 from the.earth.li (keyserver,web,email)




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#625828; Package libipc-sharelite-perl. (Tue, 10 May 2011 12:18:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Tue, 10 May 2011 12:18:05 GMT) Full text and rfc822 format available.

Message #24 received at 625828@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: Dominic Hargreaves <dom@earth.li>
Cc: 625828@bugs.debian.org
Subject: Re: Bug#625828: libipc-sharelite-perl: FTBFS on armel: test failures
Date: Tue, 10 May 2011 15:16:09 +0300
On Tue, May 10, 2011 at 12:31:39PM +0100, Dominic Hargreaves wrote:
> On Sun, May 08, 2011 at 09:43:55AM +0300, Niko Tyni wrote:
> > On Fri, May 06, 2011 at 12:38:42PM +0300, Niko Tyni wrote:
> > > Package: libipc-sharelite-perl
> > > Version: 0.17-1
> > > Severity: serious
> > > Tags: wheezy sid
> > > User: debian-perl@lists.debian.org
> > > Usertags: perl-5.12-transition
> > > 
> > > This package failed to build on armel only against Perl 5.12.
> > > 
> > >  https://buildd.debian.org/status/fetch.php?pkg=libipc-sharelite-perl&arch=armel&ver=0.17-1%2Bb1&stamp=1304522076
> > 
> > > Haven't investigated whether this is a regression with Perl 5.12 or
> > > something else. The last time it was built on armel was in March 2009.
> > 
> > I can reproduce this on abel.debian.org with both squeeze (Perl 5.10)
> > and sid (5.12), but not on agricola.debian.org at all. Either kernel or
> > hardware specific? I see from the build log that arnold.debian.org (the
> > buildd) is running "Linux 2.6.32 armel (armv5tel)" which matches abel.

> I asked the release team to schedule it again, and it also failed
> on ancina.debian.org and alwyn.debian.org, so it's apparently not
> an uncommon failure on this arch.

Too bad. It's starting to look like a kernel regression from 2.6.26 to me.

Maybe we should postpone this, and solve the immediate Perl 5.12
testing migration problem with a a porter binary upload built on
agricola.debian.org (but leave this bug open as RC of course.)

There are quite a few reverse dependencies via libcache-cache-perl so
removal from wheezy doesn't seem a good option at this point.
-- 
Niko Tyni  ntyni@debian.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#625828; Package libipc-sharelite-perl. (Tue, 10 May 2011 20:51:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dominic Hargreaves <dom@earth.li>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Tue, 10 May 2011 20:51:05 GMT) Full text and rfc822 format available.

Message #29 received at 625828@bugs.debian.org (full text, mbox):

From: Dominic Hargreaves <dom@earth.li>
To: Niko Tyni <ntyni@debian.org>
Cc: 625828@bugs.debian.org
Subject: Re: Bug#625828: libipc-sharelite-perl: FTBFS on armel: test failures
Date: Tue, 10 May 2011 21:48:19 +0100
unblock 619117 by 625828
thanks

On Tue, May 10, 2011 at 03:16:09PM +0300, Niko Tyni wrote:
> Maybe we should postpone this, and solve the immediate Perl 5.12
> testing migration problem with a a porter binary upload built on
> agricola.debian.org (but leave this bug open as RC of course.)
>
> There are quite a few reverse dependencies via libcache-cache-perl so
> removal from wheezy doesn't seem a good option at this point.

Okay, done.

Dominic.

-- 
Dominic Hargreaves | http://www.larted.org.uk/~dom/
PGP key 5178E2A5 from the.earth.li (keyserver,web,email)




Removed indication that bug 625828 blocks 619117 Request was from Dominic Hargreaves <dom@earth.li> to control@bugs.debian.org. (Tue, 10 May 2011 21:06:12 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#625828; Package libipc-sharelite-perl. (Sat, 14 May 2011 06:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Sat, 14 May 2011 06:27:03 GMT) Full text and rfc822 format available.

Message #36 received at 625828@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: 625828@bugs.debian.org
Cc: debian-arm@lists.debian.org
Subject: Re: Bug#625828: libipc-sharelite-perl: FTBFS on armel: test failures
Date: Sat, 14 May 2011 09:23:36 +0300
[Message part 1 (text/plain, inline)]
On Sun, May 08, 2011 at 09:43:55AM +0300, Niko Tyni wrote:
> On Fri, May 06, 2011 at 12:38:42PM +0300, Niko Tyni wrote:
> > Package: libipc-sharelite-perl
> > Version: 0.17-1
> > Severity: serious
> > Tags: wheezy sid
> > User: debian-perl@lists.debian.org
> > Usertags: perl-5.12-transition
> > 
> > This package failed to build on armel only against Perl 5.12.
> > 
> >  https://buildd.debian.org/status/fetch.php?pkg=libipc-sharelite-perl&arch=armel&ver=0.17-1%2Bb1&stamp=1304522076

> I can reproduce this on abel.debian.org with both squeeze (Perl 5.10)
> and sid (5.12), but not on agricola.debian.org at all. Either kernel or
> hardware specific? I see from the build log that arnold.debian.org (the
> buildd) is running "Linux 2.6.32 armel (armv5tel)" which matches abel.

It also failed on ancina.d.o ("Linux 2.6.31-rc9 armel (armv5tel)")
and alwyn.d.o ("Linux 2.6.32 armel (armv5tel)"). Dominic uploaded a
binary package built on agricola.d.o (2.6.26-2-iop32x), where it
never fails.

The code uses semaphore operations for locking shared memory, and the
bug seems to be that attaching the same shared memory segment twice and
then accessing the second copy breaks locking altogether.

I have narrowed the problem down to the attached pure C test case,
which fails almost all the time for me on abel.d.o but never anywhere
else I've tried.

I'm not intimately familiar with SysV IPC, but my reading of the semop(2)
and related manual pages indicates the code should work. I think this
looks like a kernel regression on armel, but I'm certainly happy to be
proved wrong.

@debian-arm: could some porters please test this (running it a dozen
times or so to see how consistent the result is) and report back with
the results and kernel versions? Please compile it without optimization,
otherwise the memory access triggering the bug gets optimized away.

abel% while   ! ./a.out 5000; do :; done
not ok 1 - got 5000, expected 10000
not ok 1 - got 8242, expected 10000
not ok 1 - got 9342, expected 10000
not ok 1 - got 5000, expected 10000
not ok 1 - got 7159, expected 10000
not ok 1 - got 5000, expected 10000
not ok 1 - got 9223, expected 10000
ok 1 - got 10000, expected 10000

Thanks,
-- 
Niko Tyni   ntyni@debian.org
[test.c (text/x-csrc, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#625828; Package libipc-sharelite-perl. (Sat, 14 May 2011 17:18:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Loïc Minier <lool@dooz.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Sat, 14 May 2011 17:18:03 GMT) Full text and rfc822 format available.

Message #41 received at 625828@bugs.debian.org (full text, mbox):

From: Loïc Minier <lool@dooz.org>
To: Niko Tyni <ntyni@debian.org>
Cc: 625828@bugs.debian.org, debian-arm@lists.debian.org
Subject: Re: Bug#625828: libipc-sharelite-perl: FTBFS on armel: test failures
Date: Sat, 14 May 2011 19:09:00 +0200
On Sat, May 14, 2011, Niko Tyni wrote:
> > I can reproduce this on abel.debian.org with both squeeze (Perl 5.10)
> > and sid (5.12), but not on agricola.debian.org at all. Either kernel or
> > hardware specific? I see from the build log that arnold.debian.org (the
> > buildd) is running "Linux 2.6.32 armel (armv5tel)" which matches abel.
> It also failed on ancina.d.o ("Linux 2.6.31-rc9 armel (armv5tel)")
> and alwyn.d.o ("Linux 2.6.32 armel (armv5tel)"). Dominic uploaded a
> binary package built on agricola.d.o (2.6.26-2-iop32x), where it
> never fails.
> 
> The code uses semaphore operations for locking shared memory, and the
> bug seems to be that attaching the same shared memory segment twice and
> then accessing the second copy breaks locking altogether.

 There were testsuite failures sounding similar to this one in Ubuntu
 with older kernels; upgrading them solved the problem:
  https://bugs.launchpad.net/ubuntu/+source/libipc-sharelite-perl/+bug/299847

 I guess either this issue is back or the specific kernel change which
 fixed this issue should be bisected

-- 
Loïc Minier




Added indication that bug 625828 blocks 637809 Request was from Julien Cristau <jcristau@debian.org> to control@bugs.debian.org. (Thu, 17 Nov 2011 08:39:07 GMT) Full text and rfc822 format available.

Removed indication that bug 625828 blocks 637809 Request was from Dominic Hargreaves <dom@earth.li> to control@bugs.debian.org. (Fri, 18 Nov 2011 18:57:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#625828; Package libipc-sharelite-perl. (Sat, 09 Jun 2012 17:06:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to intrigeri <intrigeri@boum.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Sat, 09 Jun 2012 17:06:06 GMT) Full text and rfc822 format available.

Message #50 received at 625828@bugs.debian.org (full text, mbox):

From: intrigeri <intrigeri@boum.org>
To: debian-arm@lists.debian.org
Cc: 625828@bugs.debian.org, Niko Tyni <ntyni@debian.org>
Subject: Re: Bug#625828: libipc-sharelite-perl: FTBFS on armel: test failures
Date: Sat, 09 Jun 2012 19:03:10 +0200
Hi debian-arm,

Niko Tyni wrote (14 May 2011 06:23:36 GMT) :
> @debian-arm: could some porters please test this (running it a dozen
> times or so to see how consistent the result is) and report back with
> the results and kernel versions? Please compile it without optimization,
> otherwise the memory access triggering the bug gets optimized away.

Ping?

The test program can be found there:
http://bugs.debian.org/cgi-bin/bugreport.cgi?msg=36;filename=test.c;att=1;bug=625828

Cheers!




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#625828; Package libipc-sharelite-perl. (Sun, 17 Jun 2012 03:15:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to shawn <shawnlandden@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Sun, 17 Jun 2012 03:15:02 GMT) Full text and rfc822 format available.

Message #55 received at 625828@bugs.debian.org (full text, mbox):

From: shawn <shawnlandden@gmail.com>
To: 625828@bugs.debian.org
Subject: Re: Bug#625828: libipc-sharelite-perl: FTBFS on armel: test failures
Date: Sat, 16 Jun 2012 20:13:04 -0700
on 3.4 (custom) + sheevaplug:

$ gcc -O0 625828.c 
$ ./a.out 
ok 1 - got 2000, expected 2000

-- 
-Shawn Landden





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#625828; Package libipc-sharelite-perl. (Tue, 26 Jun 2012 05:42:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to intrigeri <intrigeri@boum.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Tue, 26 Jun 2012 05:42:02 GMT) Full text and rfc822 format available.

Message #60 received at 625828@bugs.debian.org (full text, mbox):

From: intrigeri <intrigeri@boum.org>
To: shawn <shawnlandden@gmail.com>
Cc: 625828@bugs.debian.org
Subject: Re: Bug#625828: libipc-sharelite-perl: FTBFS on armel: test failures
Date: Tue, 26 Jun 2012 07:39:04 +0200
shawn wrote (17 Jun 2012 03:13:04 GMT) :
> on 3.4 (custom) + sheevaplug:

> $ gcc -O0 625828.c 
> $ ./a.out 
> ok 1 - got 2000, expected 2000

Thank you!

Can you please run it a few dozen of times, instead of just once?

(Rationale: I've seen it pass the first time on abel.d.o, then fail
most of the time.)




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#625828; Package libipc-sharelite-perl. (Tue, 26 Jun 2012 05:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to intrigeri <intrigeri@boum.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Tue, 26 Jun 2012 05:45:03 GMT) Full text and rfc822 format available.

Message #65 received at 625828@bugs.debian.org (full text, mbox):

From: intrigeri <intrigeri@boum.org>
To: 625828@bugs.debian.org
Cc: Niko Tyni <ntyni@debian.org>, debian-arm@lists.debian.org
Subject: Re: Bug#625828: libipc-sharelite-perl: FTBFS on armel: test failures
Date: Tue, 26 Jun 2012 07:40:50 +0200
hi,

Niko Tyni wrote (14 May 2011 06:23:36 GMT) :
> I have narrowed the problem down to the attached pure C test case,
> which fails almost all the time for me on abel.d.o but never
> anywhere else I've tried.

This test case still fails almost all of the time on abel.d.o
(2.6.32, armv5tel).

Given we received one report of success on Linux 3.4,
which might indicate a kernel bug was fixed between 2.6.32 and 3.4,
what would be very useful now is test results with the current
testing/sid kernel. arm porters, anyone?




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#625828; Package libipc-sharelite-perl. (Tue, 26 Jun 2012 22:21:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to intrigeri <intrigeri@boum.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Tue, 26 Jun 2012 22:21:07 GMT) Full text and rfc822 format available.

Message #70 received at 625828@bugs.debian.org (full text, mbox):

From: intrigeri <intrigeri@boum.org>
To: 625828@bugs.debian.org
Cc: debian-arm@lists.debian.org, Niko Tyni <ntyni@debian.org>
Subject: Re: Bug#625828: libipc-sharelite-perl: FTBFS on armel: test failures
Date: Wed, 27 Jun 2012 00:20:05 +0200
shawn wrote (17 Jun 2012 03:13:04 GMT) :
> on 3.4 (custom) + sheevaplug:

> $ gcc -O0 625828.c 
> $ ./a.out 
> ok 1 - got 2000, expected 2000

I asked for more thorough testing, and shawn reported
"I ran it 500 times, it succeeded only 191 of those times."

Cheers,
--
  intrigeri
  | GnuPG key @ https://gaffer.ptitcanardnoir.org/intrigeri/intrigeri.asc
  | OTR fingerprint @ https://gaffer.ptitcanardnoir.org/intrigeri/otr.asc




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#625828; Package libipc-sharelite-perl. (Thu, 28 Jun 2012 18:24:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon Baatz <gmbnomis@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Thu, 28 Jun 2012 18:24:03 GMT) Full text and rfc822 format available.

Message #75 received at 625828@bugs.debian.org (full text, mbox):

From: Simon Baatz <gmbnomis@gmail.com>
To: intrigeri <intrigeri@boum.org>
Cc: 625828@bugs.debian.org, debian-arm@lists.debian.org, Niko Tyni <ntyni@debian.org>
Subject: Re: Bug#625828: libipc-sharelite-perl: FTBFS on armel: test failures
Date: Thu, 28 Jun 2012 20:21:28 +0200
On Wed, Jun 27, 2012 at 12:20:05AM +0200, intrigeri wrote:
> shawn wrote (17 Jun 2012 03:13:04 GMT) :
> > on 3.4 (custom) + sheevaplug:
> 
> > $ gcc -O0 625828.c 
> > $ ./a.out 
> > ok 1 - got 2000, expected 2000
> 
> I asked for more thorough testing, and shawn reported
> "I ran it 500 times, it succeeded only 191 of those times."

This seems to be another instance of VIVT L1 caching weirdness. The
problem has been discussed years ago on the arm kernel mailing list
(see [1]) and a patch has been proposed at that time.  Apparently,
that never made it into the kernel.

I think what happens in the test program is the following:

1. When mapping 1 is initialized, it is cacheable (in L1 and L2)

2. When mapping 2 is initialized (by "c = *shmaddr2;"), both mappings
   become uncacheable (neither in L1 nor L2) since they belong to the
   same process.  If they were cacheable, the two mappings could
   become incoherent within the same process. (Incoherencies between
   processes can be avoided by flushing the L1 cache at context
   switch.  However, this is not possible within a process and thus,
   the kernel sets shared mappings to uncacheable)

3. The forked process only uses mapping 1, i.e. the mapping remains
   cacheable in this process.

4. Task switches between the two processes flush the L1 caches, but
   not the L2 cache.  Since the original process does not use the L2
   cache at all and the second process uses it, the processes have
   incoherent views.

If this theory is true, the following should make the problem
disappear (tested on kirkwood):

1. Don't initialize the second mapping by "c = *shmaddr2;" -> The
mapping remains cacheable in both processes.

Problem goes away, as already stated in the original test program.

2. Initialize the second mapping in both processes. (Don't detach the
second range and move "c = *shmaddr2;" to happen after the fork.) ->
The mappings are non-cacheable in both processes.

Problem goes away.

3. Disable the L2 cache in both U-Boot and the kernel (requires to
compile the kernel with CONFIG_CACHE_FEROCEON_L2=n) -> L1 flushes now
are sufficient to ensure coherency.

Problem goes away.

This seems to support my theory...

The patch that was proposed in the thread mentioned above would
render the mapping(s) of the second process uncacheable as there are
already other uncacheable mappings (those of the original process). 
Thus, it leads to the situation described in 2 above and should fix
the problem.  Unfortunately, it does not apply to my current kernel
(3.5-rc4) anymore.  So, I could not test whether it really helps.

- Simon

[1] http://lists.infradead.org/pipermail/linux-arm-kernel/2009-December/005471.html






Bug 625828 cloned as bug 679449 Request was from intrigeri@debian.org to control@bugs.debian.org. (Thu, 28 Jun 2012 19:03:07 GMT) Full text and rfc822 format available.

Added blocking bug(s) of 625828: 679449 Request was from intrigeri@debian.org to control@bugs.debian.org. (Thu, 28 Jun 2012 19:03:10 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#625828; Package libipc-sharelite-perl. (Thu, 28 Jun 2012 19:15:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to intrigeri <intrigeri@boum.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Thu, 28 Jun 2012 19:15:06 GMT) Full text and rfc822 format available.

Message #84 received at 625828@bugs.debian.org (full text, mbox):

From: intrigeri <intrigeri@boum.org>
To: Simon Baatz <gmbnomis@gmail.com>
Cc: 625828@bugs.debian.org, debian-arm@lists.debian.org, Niko Tyni <ntyni@debian.org>
Subject: Re: Bug#625828: libipc-sharelite-perl: FTBFS on armel: test failures
Date: Thu, 28 Jun 2012 21:10:58 +0200
Simon Baatz wrote (28 Jun 2012 18:21:28 GMT) :
> This seems to be another instance of VIVT L1 caching weirdness.
> The problem has been discussed years ago on the arm kernel mailing
> list (see [1]) and a patch has been proposed at that time.
> Apparently, that never made it into the kernel.

Thanks a lot for your analysis.

I've cloned that bug and reassigned the new one to src:linux:
http://bugs.debian.org/679449




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#625828; Package libipc-sharelite-perl. (Fri, 29 Jun 2012 15:54:03 GMT) Full text and rfc822 format available.

Message #87 received at 625828@bugs.debian.org (full text, mbox):

From: pkg-perl-maintainers@lists.alioth.debian.org
To: 625828@bugs.debian.org, 625828-submitter@bugs.debian.org
Subject: Pending fixes for bugs in the libipc-sharelite-perl package
Date: Fri, 29 Jun 2012 15:51:50 +0000
tag 625828 + pending
thanks

Some bugs in the libipc-sharelite-perl package are closed in revision
eea82f6b6d57e4a888e1260f48686b093449f1d8 in branch 'master' by
intrigeri

The full diff can be seen at
http://anonscm.debian.org/gitweb/?p=pkg-perl/packages/libipc-sharelite-perl.git;a=commitdiff;h=eea82f6

Commit message:

    New patch: Disable-t-sharelite.t-Closes-625828.patch (Closes: #625828)
    
    According to Ben Hutchings, "Mapping the same shared memory twice in one process
    is stupid, anyway." (Message #99 on bug #679449).





Added tag(s) pending. Request was from pkg-perl-maintainers@lists.alioth.debian.org to control@bugs.debian.org. (Fri, 29 Jun 2012 15:54:06 GMT) Full text and rfc822 format available.

Message sent on to Niko Tyni <ntyni@debian.org>:
Bug#625828. (Fri, 29 Jun 2012 15:54:08 GMT) Full text and rfc822 format available.

Reply sent to intrigeri <intrigeri@debian.org>:
You have taken responsibility. (Fri, 29 Jun 2012 16:33:14 GMT) Full text and rfc822 format available.

Notification sent to Niko Tyni <ntyni@debian.org>:
Bug acknowledged by developer. (Fri, 29 Jun 2012 16:33:14 GMT) Full text and rfc822 format available.

Message #97 received at 625828-close@bugs.debian.org (full text, mbox):

From: intrigeri <intrigeri@debian.org>
To: 625828-close@bugs.debian.org
Subject: Bug#625828: fixed in libipc-sharelite-perl 0.17-2
Date: Fri, 29 Jun 2012 16:28:16 +0000
Source: libipc-sharelite-perl
Source-Version: 0.17-2

We believe that the bug you reported is fixed in the latest version of
libipc-sharelite-perl, which is due to be installed in the Debian FTP archive:

libipc-sharelite-perl_0.17-2.debian.tar.gz
  to main/libi/libipc-sharelite-perl/libipc-sharelite-perl_0.17-2.debian.tar.gz
libipc-sharelite-perl_0.17-2.dsc
  to main/libi/libipc-sharelite-perl/libipc-sharelite-perl_0.17-2.dsc
libipc-sharelite-perl_0.17-2_amd64.deb
  to main/libi/libipc-sharelite-perl/libipc-sharelite-perl_0.17-2_amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 625828@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
intrigeri <intrigeri@debian.org> (supplier of updated libipc-sharelite-perl package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA512

Format: 1.8
Date: Fri, 29 Jun 2012 17:27:29 +0200
Source: libipc-sharelite-perl
Binary: libipc-sharelite-perl
Architecture: source amd64
Version: 0.17-2
Distribution: unstable
Urgency: low
Maintainer: Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>
Changed-By: intrigeri <intrigeri@debian.org>
Description: 
 libipc-sharelite-perl - Perl module that provides a simple interface to shared memory
Closes: 625828
Changes: 
 libipc-sharelite-perl (0.17-2) unstable; urgency=low
 .
   * Team upload.
 .
   [ Ansgar Burchardt ]
   * debian/control: Convert Vcs-* fields to Git.
 .
   [ intrigeri ]
   * Delete Old_changes_in_diffgz.patch, that has never been enabled
     after Sarge.
   * Convert debian/copyright to copyright format 1.0.
   * Don't version dependency on perl, that is satisfied at least since Lenny.
   * New patch: Disable-t-sharelite.t-Closes-625828.patch (Closes: #625828)
   * Bump compatibility level to dh 9.
   * Migrate to tiny dh9 debian/rules.
   * Bumped Standards-Version to 3.9.3, no change required.
Checksums-Sha1: 
 b6b586d075a71d8bb08b48b15db366621af66a4f 2169 libipc-sharelite-perl_0.17-2.dsc
 12383e665b1030e8c77262844b4e449fe05a435d 4517 libipc-sharelite-perl_0.17-2.debian.tar.gz
 2b4912ca355978d62f412f23e3dc2aef7ae06fa7 27318 libipc-sharelite-perl_0.17-2_amd64.deb
Checksums-Sha256: 
 8f92a535718d83a4eaa5e2b3c08ceddf379ca5acc75c8b4bb9848fc679334804 2169 libipc-sharelite-perl_0.17-2.dsc
 caf221f30697e333ca0cb00b926ddf54ef83850f5fb64cbac173eed4b89f9aa8 4517 libipc-sharelite-perl_0.17-2.debian.tar.gz
 2b2247749526e1b1f14127d3ab53e304a3c8583aeb8c1c48ee5fc9c18ba96468 27318 libipc-sharelite-perl_0.17-2_amd64.deb
Files: 
 aae05fa0cdcf94845ea7e7b60fb4034b 2169 perl optional libipc-sharelite-perl_0.17-2.dsc
 6b0cf493cd9294153a401d31c55c2258 4517 perl optional libipc-sharelite-perl_0.17-2.debian.tar.gz
 9909aef60261ed9100fca854cec55be8 27318 perl optional libipc-sharelite-perl_0.17-2_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCgAGBQJP7c6aAAoJELrOFdKldJj/hPsQAMzI/7BoLr0do33BQP72iJXJ
by+auJpbBY3YLIdtWMC8qn+IWnj///15YOAPvHdUUBxePYk+v/35q6leJ9JaP0eq
buZutvGL8dU5yO2nQaIFSMF0eadWAQOBJjb0DvYsDKnGyThHU4PnlGmkE7hEi13T
t2HFMun8hc6WPbjjrX4MnD0EU3NUl6YNEMDYVF/L672rq8JKxuFobSYY2M0gk+eE
E25j4lz2TAcfmyi7kBehwaK9S23HC1U0PybM0G+GEamQwJr9BG9EKooxWKeIMu/2
hBtkqvSVe2WEuqYgIafT33hEJCHvgGrxhqmxHQciW4Mmtav9boiXrWR89mGrgF4x
Nj9DJYopJbLFWtgH9J7VoPikY7PhVYOPSfjfAjJ7AZ0O1A48eWXMAfSPjtJmuSKm
Ke/JNyTjo5po4yg68/ROccIjUEwSa2WxX59gosj8OW7ZNxWc9UVlI3sYkEwCV3so
XE1XOVDkJmWjPo/p96PY0wujyg6wkguEX8L0B5ugUMVuR79nlPJyrYo2v9kKSquo
91o93XNs2gDgNmXtrqcDPPIBMs4msxQskly0SIbIOcRSn+CLnkc51lNvR64hCBSk
a0MTPM7zAZDRW2EXq6d2MIV1aF97ByLJ1gHLPKQhNOD3VzGEJB0KOlXn3woA6E9H
mT71yiv6qwvrIwaKMvWd
=q9zG
-----END PGP SIGNATURE-----





Marked as found in versions linux/3.4.1-1~experimental.1 and linux-2.6/2.6.31-1~experimental.1 and reopened. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Wed, 04 Jul 2012 17:09:06 GMT) Full text and rfc822 format available.

Added tag(s) upstream. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Wed, 04 Jul 2012 17:09:07 GMT) Full text and rfc822 format available.

Removed tag(s) sid, squeeze, and wheezy. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Wed, 04 Jul 2012 17:09:07 GMT) Full text and rfc822 format available.

No longer marked as found in versions linux/3.4.1-1~experimental.1 and linux-2.6/2.6.31-1~experimental.1. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Wed, 04 Jul 2012 17:15:08 GMT) Full text and rfc822 format available.

Added tag(s) sid, squeeze, and wheezy. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Wed, 04 Jul 2012 17:15:09 GMT) Full text and rfc822 format available.

Reply sent to Jonathan Nieder <jrnieder@gmail.com>:
You have taken responsibility. (Wed, 04 Jul 2012 17:15:14 GMT) Full text and rfc822 format available.

Notification sent to Niko Tyni <ntyni@debian.org>:
Bug acknowledged by developer. (Wed, 04 Jul 2012 17:15:14 GMT) Full text and rfc822 format available.

Message #112 received at 625828-done@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: 625828-done@bugs.debian.org
Subject: Re: libipc-sharelite-perl: FTBFS on armel: test failures
Date: Wed, 4 Jul 2012 12:12:58 -0500
notfound 625828 linux-2.6/2.6.31-1~experimental.1 , linux/3.4.1-1~experimental.1
tags 625828 + squeeze wheezy sid
found 679449 linux-2.6/2.6.31-1~experimental.1 , linux/3.4.1-1~experimental.1
tags 679449 + upstream - squeeze wheezy sid
quit

Hi,

Debian Bug Tracking System wrote:

>> # reports were using 2.6.31-rc9 and upstream 3.4, but close enough
>> found 625828 linux-2.6/2.6.31-1~experimental.1 , linux/3.4.1-1~experimental.1
> Bug #625828 {Done: intrigeri <intrigeri@debian.org>} [libipc-sharelite-perl] libipc-sharelite-perl: FTBFS on armel: test failures

Wrong bug.  Sorry about that.




Added tag(s) jessie. Request was from Julien Cristau <jcristau@debian.org> to control@bugs.debian.org. (Thu, 18 Apr 2013 17:45:16 GMT) Full text and rfc822 format available.

Removed tag(s) sid, squeeze, wheezy, and jessie. Request was from Andreas Beckmann <anbe@debian.org> to control@bugs.debian.org. (Fri, 01 Nov 2013 22:32:08 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sat, 30 Nov 2013 07:40:17 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 11:30:07 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.